Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/alglibinternal.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/alglibinternal.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/alglibinternal.cs	(revision 7294)
@@ -65,9 +1399,32 @@
             ref int[] p2)
         {
+            apserv.apbuffers buf = new apserv.apbuffers();
+
+            p1 = new int[0];
+            p2 = new int[0];
+
+            tagsortbuf(ref a, n, ref p1, ref p2, buf);
+        }
+
+
+        /*************************************************************************
+        Buffered variant of TagSort, which accepts preallocated output arrays as
+        well as special structure for buffered allocations. If arrays are too
+        short, they are reallocated. If they are large enough, no memory
+        allocation is done.
+
+        It is intended to be used in the performance-critical parts of code, where
+        additional allocations can lead to severe performance degradation
+
+          -- ALGLIB --
+             Copyright 14.05.2008 by Bochkanov Sergey
+        *************************************************************************/
+        public static void tagsortbuf(ref double[] a,
+            int n,
+            ref int[] p1,
+            ref int[] p2,
+            apserv.apbuffers buf)
+        {
             int i = 0;
-            int[] pv = new int[0];
-            int[] vp = new int[0];
-            double[] bufa = new double[0];
-            int[] bufb = new int[0];
             int lv = 0;
             int lp = 0;
@@ -75,7 +1432,4 @@
             int rp = 0;
 
-            p1 = new int[0];
-            p2 = new int[0];
-
             
             //
@@ -88,6 +1442,6 @@
             if( n==1 )
             {
-                p1 = new int[0+1];
-                p2 = new int[0+1];
+                apserv.ivectorsetlengthatleast(ref p1, 1);
+                apserv.ivectorsetlengthatleast(ref p2, 1);
                 p1[0] = 0;
                 p2[0] = 0;
@@ -98,5 +1452,5 @@
             // General case, N>1: prepare permutations table P1
             //
-            p1 = new int[n-1+1];
+            apserv.ivectorsetlengthatleast(ref p1, n);
             for(i=0; i<=n-1; i++)
             {
@@ -107,7 +1461,7 @@
             // General case, N>1: sort, update P1
             //
-            bufa = new double[n];
-            bufb = new int[n];
-            tagsortfasti(ref a, ref p1, ref bufa, ref bufb, n);
+            apserv.rvectorsetlengthatleast(ref buf.ra0, n);
+            apserv.ivectorsetlengthatleast(ref buf.ia0, n);
+            tagsortfasti(ref a, ref p1, ref buf.ra0, ref buf.ia0, n);
             
             //
@@ -115,6 +1469,6 @@
             //
             // To fill P2 we maintain two arrays:
-            // * PV, Position(Value). PV[i] contains position of I-th key at the moment
-            // * VP, Value(Position). VP[i] contains key which has position I at the moment
+            // * PV (Buf.IA0), Position(Value). PV[i] contains position of I-th key at the moment
+            // * VP (Buf.IA1), Value(Position). VP[i] contains key which has position I at the moment
             //
             // At each step we making permutation of two items:
@@ -123,11 +1477,11 @@
             // and updating PV[] and VP[] correspondingly.
             //
-            pv = new int[n-1+1];
-            vp = new int[n-1+1];
-            p2 = new int[n-1+1];
+            apserv.ivectorsetlengthatleast(ref buf.ia0, n);
+            apserv.ivectorsetlengthatleast(ref buf.ia1, n);
+            apserv.ivectorsetlengthatleast(ref p2, n);
             for(i=0; i<=n-1; i++)
             {
-                pv[i] = i;
-                vp[i] = i;
+                buf.ia0[i] = i;
+                buf.ia1[i] = i;
             }
             for(i=0; i<=n-1; i++)
@@ -138,7 +1492,7 @@
                 //
                 lp = i;
-                lv = vp[lp];
+                lv = buf.ia1[lp];
                 rv = p1[i];
-                rp = pv[rv];
+                rp = buf.ia0[rv];
                 
                 //
@@ -150,8 +1504,8 @@
                 // update PV and VP
                 //
-                vp[lp] = rv;
-                vp[rp] = lv;
-                pv[lv] = rp;
-                pv[rv] = lp;
+                buf.ia1[lp] = rv;
+                buf.ia1[rp] = lv;
+                buf.ia0[lv] = rp;
+                buf.ia0[rv] = lp;
             }
         }
@@ -1183,746 +2537,4 @@
             tagsortfastrec(ref a, ref bufa, i1, i1+cntless-1);
             tagsortfastrec(ref a, ref bufa, i1+cntless+cnteq, i2);
-        }
-
-
-    }
-    public class apserv
-    {
-        /*************************************************************************
-        Buffers for internal functions which need buffers:
-        * check for size of the buffer you want to use.
-        * if buffer is too small, resize it; leave unchanged, if it is larger than
-          needed.
-        * use it.
-
-        We can pass this structure to multiple functions;  after first run through
-        functions buffer sizes will be finally determined,  and  on  a next run no
-        allocation will be required.
-        *************************************************************************/
-        public class apbuffers
-        {
-            public int[] ia1;
-            public int[] ia2;
-            public double[] ra1;
-            public double[] ra2;
-            public apbuffers()
-            {
-                ia1 = new int[0];
-                ia2 = new int[0];
-                ra1 = new double[0];
-                ra2 = new double[0];
-            }
-        };
-
-
-
-
-        /*************************************************************************
-        This  function  generates  1-dimensional  general  interpolation task with
-        moderate Lipshitz constant (close to 1.0)
-
-        If N=1 then suborutine generates only one point at the middle of [A,B]
-
-          -- ALGLIB --
-             Copyright 02.12.2009 by Bochkanov Sergey
-        *************************************************************************/
-        public static void taskgenint1d(double a,
-            double b,
-            int n,
-            ref double[] x,
-            ref double[] y)
-        {
-            int i = 0;
-            double h = 0;
-
-            x = new double[0];
-            y = new double[0];
-
-            ap.assert(n>=1, "TaskGenInterpolationEqdist1D: N<1!");
-            x = new double[n];
-            y = new double[n];
-            if( n>1 )
-            {
-                x[0] = a;
-                y[0] = 2*math.randomreal()-1;
-                h = (b-a)/(n-1);
-                for(i=1; i<=n-1; i++)
-                {
-                    if( i!=n-1 )
-                    {
-                        x[i] = a+(i+0.2*(2*math.randomreal()-1))*h;
-                    }
-                    else
-                    {
-                        x[i] = b;
-                    }
-                    y[i] = y[i-1]+(2*math.randomreal()-1)*(x[i]-x[i-1]);
-                }
-            }
-            else
-            {
-                x[0] = 0.5*(a+b);
-                y[0] = 2*math.randomreal()-1;
-            }
-        }
-
-
-        /*************************************************************************
-        This function generates  1-dimensional equidistant interpolation task with
-        moderate Lipshitz constant (close to 1.0)
-
-        If N=1 then suborutine generates only one point at the middle of [A,B]
-
-          -- ALGLIB --
-             Copyright 02.12.2009 by Bochkanov Sergey
-        *************************************************************************/
-        public static void taskgenint1dequidist(double a,
-            double b,
-            int n,
-            ref double[] x,
-            ref double[] y)
-        {
-            int i = 0;
-            double h = 0;
-
-            x = new double[0];
-            y = new double[0];
-
-            ap.assert(n>=1, "TaskGenInterpolationEqdist1D: N<1!");
-            x = new double[n];
-            y = new double[n];
-            if( n>1 )
-            {
-                x[0] = a;
-                y[0] = 2*math.randomreal()-1;
-                h = (b-a)/(n-1);
-                for(i=1; i<=n-1; i++)
-                {
-                    x[i] = a+i*h;
-                    y[i] = y[i-1]+(2*math.randomreal()-1)*h;
-                }
-            }
-            else
-            {
-                x[0] = 0.5*(a+b);
-                y[0] = 2*math.randomreal()-1;
-            }
-        }
-
-
-        /*************************************************************************
-        This function generates  1-dimensional Chebyshev-1 interpolation task with
-        moderate Lipshitz constant (close to 1.0)
-
-        If N=1 then suborutine generates only one point at the middle of [A,B]
-
-          -- ALGLIB --
-             Copyright 02.12.2009 by Bochkanov Sergey
-        *************************************************************************/
-        public static void taskgenint1dcheb1(double a,
-            double b,
-            int n,
-            ref double[] x,
-            ref double[] y)
-        {
-            int i = 0;
-
-            x = new double[0];
-            y = new double[0];
-
-            ap.assert(n>=1, "TaskGenInterpolation1DCheb1: N<1!");
-            x = new double[n];
-            y = new double[n];
-            if( n>1 )
-            {
-                for(i=0; i<=n-1; i++)
-                {
-                    x[i] = 0.5*(b+a)+0.5*(b-a)*Math.Cos(Math.PI*(2*i+1)/(2*n));
-                    if( i==0 )
-                    {
-                        y[i] = 2*math.randomreal()-1;
-                    }
-                    else
-                    {
-                        y[i] = y[i-1]+(2*math.randomreal()-1)*(x[i]-x[i-1]);
-                    }
-                }
-            }
-            else
-            {
-                x[0] = 0.5*(a+b);
-                y[0] = 2*math.randomreal()-1;
-            }
-        }
-
-
-        /*************************************************************************
-        This function generates  1-dimensional Chebyshev-2 interpolation task with
-        moderate Lipshitz constant (close to 1.0)
-
-        If N=1 then suborutine generates only one point at the middle of [A,B]
-
-          -- ALGLIB --
-             Copyright 02.12.2009 by Bochkanov Sergey
-        *************************************************************************/
-        public static void taskgenint1dcheb2(double a,
-            double b,
-            int n,
-            ref double[] x,
-            ref double[] y)
-        {
-            int i = 0;
-
-            x = new double[0];
-            y = new double[0];
-
-            ap.assert(n>=1, "TaskGenInterpolation1DCheb2: N<1!");
-            x = new double[n];
-            y = new double[n];
-            if( n>1 )
-            {
-                for(i=0; i<=n-1; i++)
-                {
-                    x[i] = 0.5*(b+a)+0.5*(b-a)*Math.Cos(Math.PI*i/(n-1));
-                    if( i==0 )
-                    {
-                        y[i] = 2*math.randomreal()-1;
-                    }
-                    else
-                    {
-                        y[i] = y[i-1]+(2*math.randomreal()-1)*(x[i]-x[i-1]);
-                    }
-                }
-            }
-            else
-            {
-                x[0] = 0.5*(a+b);
-                y[0] = 2*math.randomreal()-1;
-            }
-        }
-
-
-        /*************************************************************************
-        This function checks that all values from X[] are distinct. It does more
-        than just usual floating point comparison:
-        * first, it calculates max(X) and min(X)
-        * second, it maps X[] from [min,max] to [1,2]
-        * only at this stage actual comparison is done
-
-        The meaning of such check is to ensure that all values are "distinct enough"
-        and will not cause interpolation subroutine to fail.
-
-        NOTE:
-            X[] must be sorted by ascending (subroutine ASSERT's it)
-
-          -- ALGLIB --
-             Copyright 02.12.2009 by Bochkanov Sergey
-        *************************************************************************/
-        public static bool aredistinct(double[] x,
-            int n)
-        {
-            bool result = new bool();
-            double a = 0;
-            double b = 0;
-            int i = 0;
-            bool nonsorted = new bool();
-
-            ap.assert(n>=1, "APSERVAreDistinct: internal error (N<1)");
-            if( n==1 )
-            {
-                
-                //
-                // everything is alright, it is up to caller to decide whether it
-                // can interpolate something with just one point
-                //
-                result = true;
-                return result;
-            }
-            a = x[0];
-            b = x[0];
-            nonsorted = false;
-            for(i=1; i<=n-1; i++)
-            {
-                a = Math.Min(a, x[i]);
-                b = Math.Max(b, x[i]);
-                nonsorted = nonsorted | (double)(x[i-1])>=(double)(x[i]);
-            }
-            ap.assert(!nonsorted, "APSERVAreDistinct: internal error (not sorted)");
-            for(i=1; i<=n-1; i++)
-            {
-                if( (double)((x[i]-a)/(b-a)+1)==(double)((x[i-1]-a)/(b-a)+1) )
-                {
-                    result = false;
-                    return result;
-                }
-            }
-            result = true;
-            return result;
-        }
-
-
-        /*************************************************************************
-        This function checks that all values from X[] are finite
-
-          -- ALGLIB --
-             Copyright 18.06.2010 by Bochkanov Sergey
-        *************************************************************************/
-        public static bool isfinitevector(double[] x,
-            int n)
-        {
-            bool result = new bool();
-            int i = 0;
-
-            ap.assert(n>=0, "APSERVIsFiniteVector: internal error (N<0)");
-            for(i=0; i<=n-1; i++)
-            {
-                if( !math.isfinite(x[i]) )
-                {
-                    result = false;
-                    return result;
-                }
-            }
-            result = true;
-            return result;
-        }
-
-
-        /*************************************************************************
-        This function checks that all values from X[] are finite
-
-          -- ALGLIB --
-             Copyright 18.06.2010 by Bochkanov Sergey
-        *************************************************************************/
-        public static bool isfinitecvector(complex[] z,
-            int n)
-        {
-            bool result = new bool();
-            int i = 0;
-
-            ap.assert(n>=0, "APSERVIsFiniteCVector: internal error (N<0)");
-            for(i=0; i<=n-1; i++)
-            {
-                if( !math.isfinite(z[i].x) | !math.isfinite(z[i].y) )
-                {
-                    result = false;
-                    return result;
-                }
-            }
-            result = true;
-            return result;
-        }
-
-
-        /*************************************************************************
-        This function checks that all values from X[0..M-1,0..N-1] are finite
-
-          -- ALGLIB --
-             Copyright 18.06.2010 by Bochkanov Sergey
-        *************************************************************************/
-        public static bool apservisfinitematrix(double[,] x,
-            int m,
-            int n)
-        {
-            bool result = new bool();
-            int i = 0;
-            int j = 0;
-
-            ap.assert(n>=0, "APSERVIsFiniteMatrix: internal error (N<0)");
-            ap.assert(m>=0, "APSERVIsFiniteMatrix: internal error (M<0)");
-            for(i=0; i<=m-1; i++)
-            {
-                for(j=0; j<=n-1; j++)
-                {
-                    if( !math.isfinite(x[i,j]) )
-                    {
-                        result = false;
-                        return result;
-                    }
-                }
-            }
-            result = true;
-            return result;
-        }
-
-
-        /*************************************************************************
-        This function checks that all values from X[0..M-1,0..N-1] are finite
-
-          -- ALGLIB --
-             Copyright 18.06.2010 by Bochkanov Sergey
-        *************************************************************************/
-        public static bool apservisfinitecmatrix(complex[,] x,
-            int m,
-            int n)
-        {
-            bool result = new bool();
-            int i = 0;
-            int j = 0;
-
-            ap.assert(n>=0, "APSERVIsFiniteCMatrix: internal error (N<0)");
-            ap.assert(m>=0, "APSERVIsFiniteCMatrix: internal error (M<0)");
-            for(i=0; i<=m-1; i++)
-            {
-                for(j=0; j<=n-1; j++)
-                {
-                    if( !math.isfinite(x[i,j].x) | !math.isfinite(x[i,j].y) )
-                    {
-                        result = false;
-                        return result;
-                    }
-                }
-            }
-            result = true;
-            return result;
-        }
-
-
-        /*************************************************************************
-        This function checks that all values from upper/lower triangle of
-        X[0..N-1,0..N-1] are finite
-
-          -- ALGLIB --
-             Copyright 18.06.2010 by Bochkanov Sergey
-        *************************************************************************/
-        public static bool isfinitertrmatrix(double[,] x,
-            int n,
-            bool isupper)
-        {
-            bool result = new bool();
-            int i = 0;
-            int j1 = 0;
-            int j2 = 0;
-            int j = 0;
-
-            ap.assert(n>=0, "APSERVIsFiniteRTRMatrix: internal error (N<0)");
-            for(i=0; i<=n-1; i++)
-            {
-                if( isupper )
-                {
-                    j1 = i;
-                    j2 = n-1;
-                }
-                else
-                {
-                    j1 = 0;
-                    j2 = i;
-                }
-                for(j=j1; j<=j2; j++)
-                {
-                    if( !math.isfinite(x[i,j]) )
-                    {
-                        result = false;
-                        return result;
-                    }
-                }
-            }
-            result = true;
-            return result;
-        }
-
-
-        /*************************************************************************
-        This function checks that all values from upper/lower triangle of
-        X[0..N-1,0..N-1] are finite
-
-          -- ALGLIB --
-             Copyright 18.06.2010 by Bochkanov Sergey
-        *************************************************************************/
-        public static bool apservisfinitectrmatrix(complex[,] x,
-            int n,
-            bool isupper)
-        {
-            bool result = new bool();
-            int i = 0;
-            int j1 = 0;
-            int j2 = 0;
-            int j = 0;
-
-            ap.assert(n>=0, "APSERVIsFiniteCTRMatrix: internal error (N<0)");
-            for(i=0; i<=n-1; i++)
-            {
-                if( isupper )
-                {
-                    j1 = i;
-                    j2 = n-1;
-                }
-                else
-                {
-                    j1 = 0;
-                    j2 = i;
-                }
-                for(j=j1; j<=j2; j++)
-                {
-                    if( !math.isfinite(x[i,j].x) | !math.isfinite(x[i,j].y) )
-                    {
-                        result = false;
-                        return result;
-                    }
-                }
-            }
-            result = true;
-            return result;
-        }
-
-
-        /*************************************************************************
-        This function checks that all values from X[0..M-1,0..N-1] are  finite  or
-        NaN's.
-
-          -- ALGLIB --
-             Copyright 18.06.2010 by Bochkanov Sergey
-        *************************************************************************/
-        public static bool apservisfiniteornanmatrix(double[,] x,
-            int m,
-            int n)
-        {
-            bool result = new bool();
-            int i = 0;
-            int j = 0;
-
-            ap.assert(n>=0, "APSERVIsFiniteOrNaNMatrix: internal error (N<0)");
-            ap.assert(m>=0, "APSERVIsFiniteOrNaNMatrix: internal error (M<0)");
-            for(i=0; i<=m-1; i++)
-            {
-                for(j=0; j<=n-1; j++)
-                {
-                    if( !(math.isfinite(x[i,j]) | Double.IsNaN(x[i,j])) )
-                    {
-                        result = false;
-                        return result;
-                    }
-                }
-            }
-            result = true;
-            return result;
-        }
-
-
-        /*************************************************************************
-        Safe sqrt(x^2+y^2)
-
-          -- ALGLIB --
-             Copyright by Bochkanov Sergey
-        *************************************************************************/
-        public static double safepythag2(double x,
-            double y)
-        {
-            double result = 0;
-            double w = 0;
-            double xabs = 0;
-            double yabs = 0;
-            double z = 0;
-
-            xabs = Math.Abs(x);
-            yabs = Math.Abs(y);
-            w = Math.Max(xabs, yabs);
-            z = Math.Min(xabs, yabs);
-            if( (double)(z)==(double)(0) )
-            {
-                result = w;
-            }
-            else
-            {
-                result = w*Math.Sqrt(1+math.sqr(z/w));
-            }
-            return result;
-        }
-
-
-        /*************************************************************************
-        Safe sqrt(x^2+y^2)
-
-          -- ALGLIB --
-             Copyright by Bochkanov Sergey
-        *************************************************************************/
-        public static double safepythag3(double x,
-            double y,
-            double z)
-        {
-            double result = 0;
-            double w = 0;
-
-            w = Math.Max(Math.Abs(x), Math.Max(Math.Abs(y), Math.Abs(z)));
-            if( (double)(w)==(double)(0) )
-            {
-                result = 0;
-                return result;
-            }
-            x = x/w;
-            y = y/w;
-            z = z/w;
-            result = w*Math.Sqrt(math.sqr(x)+math.sqr(y)+math.sqr(z));
-            return result;
-        }
-
-
-        /*************************************************************************
-        Safe division.
-
-        This function attempts to calculate R=X/Y without overflow.
-
-        It returns:
-        * +1, if abs(X/Y)>=MaxRealNumber or undefined - overflow-like situation
-              (no overlfow is generated, R is either NAN, PosINF, NegINF)
-        *  0, if MinRealNumber<abs(X/Y)<MaxRealNumber or X=0, Y<>0
-              (R contains result, may be zero)
-        * -1, if 0<abs(X/Y)<MinRealNumber - underflow-like situation
-              (R contains zero; it corresponds to underflow)
-
-        No overflow is generated in any case.
-
-          -- ALGLIB --
-             Copyright by Bochkanov Sergey
-        *************************************************************************/
-        public static int saferdiv(double x,
-            double y,
-            ref double r)
-        {
-            int result = 0;
-
-            r = 0;
-
-            
-            //
-            // Two special cases:
-            // * Y=0
-            // * X=0 and Y<>0
-            //
-            if( (double)(y)==(double)(0) )
-            {
-                result = 1;
-                if( (double)(x)==(double)(0) )
-                {
-                    r = Double.NaN;
-                }
-                if( (double)(x)>(double)(0) )
-                {
-                    r = Double.PositiveInfinity;
-                }
-                if( (double)(x)<(double)(0) )
-                {
-                    r = Double.NegativeInfinity;
-                }
-                return result;
-            }
-            if( (double)(x)==(double)(0) )
-            {
-                r = 0;
-                result = 0;
-                return result;
-            }
-            
-            //
-            // make Y>0
-            //
-            if( (double)(y)<(double)(0) )
-            {
-                x = -x;
-                y = -y;
-            }
-            
-            //
-            //
-            //
-            if( (double)(y)>=(double)(1) )
-            {
-                r = x/y;
-                if( (double)(Math.Abs(r))<=(double)(math.minrealnumber) )
-                {
-                    result = -1;
-                    r = 0;
-                }
-                else
-                {
-                    result = 0;
-                }
-            }
-            else
-            {
-                if( (double)(Math.Abs(x))>=(double)(math.maxrealnumber*y) )
-                {
-                    if( (double)(x)>(double)(0) )
-                    {
-                        r = Double.PositiveInfinity;
-                    }
-                    else
-                    {
-                        r = Double.NegativeInfinity;
-                    }
-                    result = 1;
-                }
-                else
-                {
-                    r = x/y;
-                    result = 0;
-                }
-            }
-            return result;
-        }
-
-
-        /*************************************************************************
-        This function makes periodic mapping of X to [A,B].
-
-        It accepts X, A, B (A>B). It returns T which lies in  [A,B] and integer K,
-        such that X = T + K*(B-A).
-
-        NOTES:
-        * K is represented as real value, although actually it is integer
-        * T is guaranteed to be in [A,B]
-        * T replaces X
-
-          -- ALGLIB --
-             Copyright by Bochkanov Sergey
-        *************************************************************************/
-        public static void apperiodicmap(ref double x,
-            double a,
-            double b,
-            ref double k)
-        {
-            k = 0;
-
-            ap.assert((double)(a)<(double)(b), "APPeriodicMap: internal error!");
-            k = (int)Math.Floor((x-a)/(b-a));
-            x = x-k*(b-a);
-            while( (double)(x)<(double)(a) )
-            {
-                x = x+(b-a);
-                k = k-1;
-            }
-            while( (double)(x)>(double)(b) )
-            {
-                x = x-(b-a);
-                k = k+1;
-            }
-            x = Math.Max(x, a);
-            x = Math.Min(x, b);
-        }
-
-
-        /*************************************************************************
-        'bounds' value: maps X to [B1,B2]
-
-          -- ALGLIB --
-             Copyright 20.03.2009 by Bochkanov Sergey
-        *************************************************************************/
-        public static double boundval(double x,
-            double b1,
-            double b2)
-        {
-            double result = 0;
-
-            if( (double)(x)<=(double)(b1) )
-            {
-                result = b1;
-                return result;
-            }
-            if( (double)(x)>=(double)(b2) )
-            {
-                result = b2;
-                return result;
-            }
-            result = x;
-            return result;
         }
 
@@ -4035,4 +4647,29 @@
     public class rotations
     {
+        /*************************************************************************
+        Application of a sequence of  elementary rotations to a matrix
+
+        The algorithm pre-multiplies the matrix by a sequence of rotation
+        transformations which is given by arrays C and S. Depending on the value
+        of the IsForward parameter either 1 and 2, 3 and 4 and so on (if IsForward=true)
+        rows are rotated, or the rows N and N-1, N-2 and N-3 and so on, are rotated.
+
+        Not the whole matrix but only a part of it is transformed (rows from M1 to
+        M2, columns from N1 to N2). Only the elements of this submatrix are changed.
+
+        Input parameters:
+            IsForward   -   the sequence of the rotation application.
+            M1,M2       -   the range of rows to be transformed.
+            N1, N2      -   the range of columns to be transformed.
+            C,S         -   transformation coefficients.
+                            Array whose index ranges within [1..M2-M1].
+            A           -   processed matrix.
+            WORK        -   working array whose index ranges within [N1..N2].
+
+        Output parameters:
+            A           -   transformed matrix.
+
+        Utility subroutine.
+        *************************************************************************/
         public static void applyrotationsfromtheleft(bool isforward,
             int m1,
@@ -4177,4 +4814,29 @@
 
 
+        /*************************************************************************
+        Application of a sequence of  elementary rotations to a matrix
+
+        The algorithm post-multiplies the matrix by a sequence of rotation
+        transformations which is given by arrays C and S. Depending on the value
+        of the IsForward parameter either 1 and 2, 3 and 4 and so on (if IsForward=true)
+        rows are rotated, or the rows N and N-1, N-2 and N-3 and so on are rotated.
+
+        Not the whole matrix but only a part of it is transformed (rows from M1
+        to M2, columns from N1 to N2). Only the elements of this submatrix are changed.
+
+        Input parameters:
+            IsForward   -   the sequence of the rotation application.
+            M1,M2       -   the range of rows to be transformed.
+            N1, N2      -   the range of columns to be transformed.
+            C,S         -   transformation coefficients.
+                            Array whose index ranges within [1..N2-N1].
+            A           -   processed matrix.
+            WORK        -   working array whose index ranges within [M1..M2].
+
+        Output parameters:
+            A           -   transformed matrix.
+
+        Utility subroutine.
+        *************************************************************************/
         public static void applyrotationsfromtheright(bool isforward,
             int m1,
@@ -4315,4 +4977,12 @@
 
 
+        /*************************************************************************
+        The subroutine generates the elementary rotation, so that:
+
+        [  CS  SN  ]  .  [ F ]  =  [ R ]
+        [ -SN  CS  ]     [ G ]     [ 0 ]
+
+        CS**2 + SN**2 = 1
+        *************************************************************************/
         public static void generaterotation(double f,
             double g,
